//
/**************************************************************
	Iecan Polka like sound (Miku Hatsune ver)
	Program Copyrights(C)2008  air variable
	http://www.ne.jp/asahi/air/variable/
	version 5.00 July,10,2008
	PIC12F629 , MPLAB8.10 w/Hitech PICC Lite 9.60PL1	
**************************************************************/

/*
port assignment
1	VDD						8	VSS
2	GP5	O SONG LED(pos)		7	GP0	(PGD)
3	GP4	O negiport(pos)		6	GP1	(PGC)
4	GP3	I SWITCH(VPP)		5	GP2	O	PIEZO_OUT

VDD 2.2V to 5V
GP3(4) MUST PULLUP driven 10K OHM
attention:
Do not press GP3 of push switch when Pickit2/ICD2 is active.
*/

//#include <pic.h>	//use when plcc lite version less than 9.60.
#include <htc.h>
#include "delay.h"

// tone Frequency set (as apend of soft delay 4)
#define	CL  	 19,
#define	C$L 	 33,
#define	DL  	 45,
#define	D$L 	 57,
#define	EL  	 68,
#define	FL  	 79,
#define	F$L 	 89,
#define	GL  	 99,
#define	G$L 	108,
#define	AL  	116,
#define	A$L 	124,
#define	BL  	131,
#define	C   	139,
#define	C$  	145,
#define	D   	152,
#define	D$  	158,
#define	E   	163,
#define	F   	169,
#define	F$  	174,
#define	G   	178,
#define	G$  	183,
#define	A   	187,
#define	A$  	191,
#define	B   	195,
#define	CH  	198,
#define	C$H 	202,
#define	DH  	205,
#define	D$H 	208,
#define	EH  	211,
#define	FH  	213,
#define	F$H 	216,
#define	GH  	218,
#define	G$H 	220,
#define	AH  	222,
#define	A$H 	224,
#define	BH  	226,
#define	R   	  0,
#define	CMD		255,
#define	END  	0
#define	TEMPO	,

//Length (Midi timebase like 48 tick)
#define	L1		192,	//whole
#define	L2		96,		//half
#define	L3		64,		//triplets half
#define	L4		48,		//quater
#define L4D		72,		//dotted quater
#define	L6		32,		//triplets quater
#define	L8		24,		//eighth
#define	L8D		36,		//dotted eighth
#define	L12		16,		//triplets eighth
#define	L16		12,		//sixteenth
#define	L16D	18,		//dotted sixteenth
#define	L24		8,		//triplets sixteenth
#define	L32		6,		//32th
#define	L32D	9,		//dotted 32th
#define	L48		4,		//triplets 32th
#define	L64		3,		//64th
#define	L96		2,		//triplets 64th
#define	L192	1,		//192th(The minimum unit)
//Length (48 ticks timebase with rest time)
#define	T192	144,0,48,	//whole
#define	T96		72,0,24,	//half
#define	T64		48,0,16,	//triplets half
#define	T48		36,0,12,	//quater
#define T72		54,0,18,	//dotted quater
#define	T32		24,0,8,		//triplets quater
#define	T24		18,0,6,		//eighth
#define	T36		27,0,9,		//dotted eighth
#define	T16		12,0,4,		//triplets eighth
#define	T12		9,0,3,		//sixteenth
#define	T18		14,0,4,		//dotted sixteenth
#define	T8		6,0,2,		//triplets sixteenth
#define	T6		5,0,1,		//32th
#define	T9		7,0,2,		//dotted 32th
#define	T4		3,0,1,		//triplets 32th
#define	T3		2,0,1,		//64th
#define	T2		1,0,1,		//triplets 64th
#define	T1		1,			//192th(The minimum unit)


//output port is
//								//		76543210
#define sound_output 	0x04	//gpio2 00000100
#define negi_output 	0x10 	//gpio4 00010000
#define led_output 		0x20 	//gpio5 00100000
#define negiport		GPIO4	//negiport 
#define ledport			GPIO5	//ledport 

#define keyinput 		0x08 	//gpio3	00001000
#define song_times		2		//repeat times
//Tempo trim (0 to 4)
#define tempo_multi 8;

//SONG DATA 

const unsigned char songdata[]={
	CMD 160 TEMPO	//tempocont (except 255)

	//1
	C$	T24
	F$	T24
	F$	T24
	F$	T12
	G$	T12
	A	T12
	A	T12
	F$	T24
	F$	T24
	F$	T12
	A	T12
	
	//2
	G$	T24
	E	T24
	E	T24
	E	T12
	G$	T12
	G$	T12
	G$	T12
	F$	T24
	F$	T48
	
	//3
	C$	T24
	F$	T24
	F$	T24
	F$	T12
	G$	T12
	A	T24
	F$	T12
	F$	T24
	F$	T12
	F$	T12
	A	T12
	
	//4
	C$H	T12
	C$H	T12
	C$H	T12
	B	T12
	A	T24
	G$	T24
	A	T12
	A	T12
	F$	T12
	F$	T12
	F$	T24
	F$	T12
	A	T12
	
	//5
	C$H	T24
	C$H	T24
	B	T24
	A	T24
	G$	T12
	G$	T12
	E	T12
	E	T12
	E	T24
	E	T12
	G$	T12
	
	//6
	B	T12
	B	T12
	B	T12
	B	T12
	A	T24
	G$	T12
	G$	T12
	A	T24
	F$	T12
	F$	T12
	F$	T36
	F$	T12
	
	//7
	C$H	T24
	C$H	T24
	B	T24
	A	T24
	G$	T24
	E	T12
	E	T12
	E	T24
	E	T12
	G$	T12
	
	//8
	B	T12
	B	T12
	B	T12
	B	T12
	A	T12
	A	T12
	G$	T12
	G$	T12
	F$	T48
	R	L8D
	F$	T12
	
	//1(9)
	C$	T24
	F$	T24
	F$	T24
	F$	T12
	G$	T12
	A	T12
	A	T12
	F$	T24
	F$	T24
	F$	T12
	A	T12
	
	//2(10)
	G$	T24
	E	T24
	E	T24
	E	T12
	G$	T12
	G$	T12
	G$	T12
	F$	T24
	F$	T48
	
	//3(11)
	C$	T24
	F$	T24
	F$	T24
	F$	T12
	G$	T12
	A	T24
	F$	T12
	F$	T24
	F$	T12
	F$	T12
	A	T12
	
	//4(12)
	C$H	T12
	C$H	T12
	C$H	T12
	B	T12
	A	T24
	G$	T24
	A	T12
	A	T12
	F$	T12
	F$	T12
	F$	T24
	F$	T12
	A	T12
	
	//5(13)
	C$H	T24
	C$H	T24
	B	T24
	A	T24
	G$	T12
	G$	T12
	E	T12
	E	T12
	E	T24
	E	T12
	G$	T12
	
	//6(14)
	B	T12
	B	T12
	B	T12
	B	T12
	A	T24
	G$	T12
	G$	T12
	A	T24
	F$	T12
	F$	T12
	F$	T36
	F$	T12
	
	//7(15)
	C$H	T24
	C$H	T24
	B	T24
	A	T24
	G$	T24
	E	T12
	E	T12
	E	T24
	E	T12
	G$	T12
	
	//8(16)
	B	T12
	B	T12
	B	T12
	B	T12
	A	T12
	A	T12
	G$	T12
	G$	T12
	F$	T48
	R	L4

	//stop
	CMD END	// Music Last of data 
};


//see Configr -> Configuration Bits...
//__CONFIG(0x3fc4);
__CONFIG(UNPROTECT & BORDIS & MCLRDIS & PWRTEN & WDTDIS & INTIO);

unsigned char tone,halfbeat=0;
unsigned char tempocont = 100;//Default TEMPO

//Timer Int process/
void interrupt toneset( void )
{
	TMR0 = tone;
	if (tone != 0) 	GPIO ^= sound_output ;//alternate port 
	T0IF =0;
	if ( ( halfbeat >= 0) && ( halfbeat <=12) ) negiport = 0; else negiport =1;
}

//tempo control
void beat_wait(unsigned char t0)
{
	int i,t1;
	for ( i=0 ; i != t0 ;++i)
		{
		t1 = tempocont * tempo_multi;
		while ( --t1 );
		halfbeat++;
		if ( halfbeat > ((192/4)-1) ) halfbeat =0;//halfbeat check
	}
}

void sleep_control(void){
	unsigned char tmp=2;
	//power up flash
	while(tmp--){
		GPIO &= ~led_output;//LED flash
		DelayMs(20);
		GPIO |= led_output;//LED flash off
		DelayMs(20);
		}
	GIE  = 0;//Int off
	T0IE = 0;//timer interrupt is off
	while ( (GPIO & keyinput)==0 );//wait if key is pushing
	TRISIO 	= 0b00111111;//GPIO0 is all input
	NOP();	//Stabilize time
	IOCB = keyinput	;//key pole ***
	GIE  = 0;//Interrupt service is disable
	GPIF  = 0;//GPIF flag clear
	GPIE  = 1;//Sleep Wakeup enable

	//vector non jump and execute next command
	SLEEP();//sleep!
	NOP();//Wake up

	// Wakeup when GPIO0 is LOW 
	GPIE = 0;//GPIO int desable
	GPIF = 0;//GPIO int flag reset
	T0IE = 1;//timer on
	GPIO = GPIO;	// Bug avoid
	TRISIO =  ~(sound_output|led_output|negi_output);//LED and piezo (GP2,4,5)
//	WPU  = keyinput;//
	GIE	 = 1; //Interrupt is All enable	
	GPIO &= ~led_output;//LED flash
	while ( (GPIO & keyinput)==0 );//wait if key is pushing
	DelayMs(50);
}
	
main(){
//Initialization

	int n=0;
	unsigned char tmp,tmp2,song_repeat=2;
	OSCCAL = _READ_OSCCAL_DATA();	//OSCCAL AUTO SET
	CMCON  = 7;		//All ports are digital I/O.
//	#if _12F675
//	ANSEL  = 0b00000000; //when device is 12F675
//	#endif

	OPTION = 0b00000010; // prescale 8 pullup enable
	WPU    = 0b00110111;//input Pin Pull Up(then Low power)
	GPIO   = 0b00000000;
	TRISIO =  ~(sound_output|led_output|negi_output);//LED and piezo (GP2,4,5)
	TMR0 =0x00 ;
	PEIE = 1;
	GIE  = 1;
	tone =0x00;
	T0IE = 1;
	sleep_control();//sleep
	while(1){	
		//command detect
		tmp=songdata[n];
		tmp2=songdata[n+1];
		if (tmp == 255) {	//Command?
			if (tmp2 == 0){	//Tempo or End of data?
				n=0;
				halfbeat = 0;
				if (--song_repeat ==0){
					sleep_control();//sleep
					song_repeat = song_times;
				}	 
			}
			else{
				tempocont = tmp2;	//New tempo change
				n +=2;
			}
		}
		else{
			if ((GPIO&keyinput)==0) sleep_control();// resume
			tone=tmp;
			if( tmp ==0 ) ledport = 1 ;
			else ledport = 0;
			beat_wait(tmp2);
//			GPIO ^= led_output;//LED flash
			n +=2;		
		}
	}
}
